
Core - Bug # 52245

Status: Rejected Priority: Should have
Author: Fabien Udriot Category: File Abstraction Layer (FAL)
Created: 2013-09-25 Assigned To:
Updated: 2013-11-16 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: medium
Is Regression: No
Sprint Focus:
Subject: Revert BackendUtility::BEenableFields in FAL
Description

Quite recently, in https://review.typo3.org/#/c/23742/, method 
BackendUtility::BEenableFields was introduced in FAL.

This has a drawback for third party extensions which are introducing 
additional enabledFields for a File.  As instance, Media has the "hidden" 
flag enabled. Consequently, FAL is not anymore capable of finding a 
File that has hidden = 1 ; $fileRepository->findByUid(123) is raising 
exception #1314354065 whenever file "123" is marked as hidden.

Since we don't have Query Settings like in Extbase, the patch
removes this constraint following the List module practice which 
displays all records except the deleted ones.

Releases: 6.0, 6.1, 6.2
Fixes: #52236

Related issues:
related to Core - Bug # 51562: sys_file records marked as deleted crash file ... Resolved 2013-08-30
related to Media Management - Bug # 52236: Fatal error when record is hidden Resolved 2013-09-24

History
#1 - 2013-09-25 10:30 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24040

#2 - 2013-09-25 11:09 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24040

#3 - 2013-09-25 11:09 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24040

#4 - 2013-09-25 11:21 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24040

#5 - 2013-09-25 11:38 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24040

#6 - 2013-09-25 11:50 - Markus Klein

I guess this approach will break extensions, relying on this behaviour.
What if you need the "not-enabled" records in FE too?

I think we should add a possibility to modify this behaviour on the fly by introducing some new API.

#7 - 2013-09-25 16:30 - Fabien Udriot

I guess this approach will break extensions, relying on this behaviour.
What if you need the "not-enabled" records in FE too?

FE? Please read carefully the commit message. This patch only addresses the BE (and does not touch the FE in any means).

Look at the method getWhereClauseForEnabledFields in this patch which clearly makes the distinction btw BE and FE.
https://review.typo3.org/#/c/23742/3/typo3/sysext/core/Classes/Resource/AbstractRepository.php

Furthermore, before the patch was merged (14 days ago) the behaviour was the opposite and is currently breaking Media @see #52236

I think we should add a possibility to modify this behaviour on the fly by introducing some new API.

As somehow expressed in the commit message, we could have this but it is the kind of thing that requires time. To quickly have Media fixed (and other
extensions if they use this in the BE), I would prefer to have the default behaviour of the List module: list everything regardless of starttime, endtime,
disable except the deleted flag.

#8 - 2013-10-16 10:45 - Fabien Udriot

This issue can be abandoned. It has been discussed that enable fields don't suit in the FAL concept where a file record is a strict representation of a
file. With the new "sys_file_metadata" in 6.2, some fields like "visible" have been introduced for controlling visibility on the FE by a gallery plugin as
example.

#9 - 2013-11-16 07:14 - Steffen Ritter
- Status changed from Under Review to Rejected

2015-08-04 2/3

https://review.typo3.org/24040
https://review.typo3.org/24040
https://review.typo3.org/24040
https://review.typo3.org/#/c/23742/3/typo3/sysext/core/Classes/Resource/AbstractRepository.php


2015-08-04 3/3


